from dataiku.customwebapp import get_webapp_config
import dataiku
from flask import request,jsonify,Response
import logging
import requests
import os
import json
import flask

logger = logging.getLogger(__name__)
config = get_webapp_config()
project_key = dataiku.default_project_key()
client = dataiku.api_client()

endpoint = "https://api.natif.ai/"
@app.route("/extract_id", methods=["GET", "POST"])
def get_id():
    url_string = str(request.args.get("backend_url"))
    return json.dumps({"status": "ok", "backend_url": url_string})

@app.route("/user-management/<string:user>", methods=["GET", "POST"])
def proxy_user_management(user):
    myurl=request.url.replace(request.host_url, 'https://api.natif.ai/')
    resp = requests.request(
        method=request.method,
        url=myurl,
        headers={key: value for (key, value) in request.headers if key != 'Host'},
        data=request.get_data(),
        cookies=request.cookies,
        allow_redirects=True)
    url=request.url.replace(request.host_url, 'https://api.natif.ai/')
    excluded_headers = ['content-encoding', 'content-length', 'transfer-encoding', 'connection']
    headers = [(name, value) for (name, value) in resp.raw.headers.items()
               if name.lower() not in excluded_headers]
    response = Response(resp.content, resp.status_code, headers)
    return response


@app.route("/documents/<string:document_id>/<string:process>", methods=["GET", "POST"])
def proxy_document(document_id,process):
    myurl=request.url.replace(request.host_url, 'https://api.natif.ai/')
    resp = requests.request(
        method=request.method,
        url=myurl,
        headers={key: value for (key, value) in request.headers if key != 'Host'},
        data=request.get_data(),
        cookies=request.cookies,
        allow_redirects=True)
    url=request.url.replace(request.host_url, 'https://api.natif.ai/')
    excluded_headers = ['content-encoding', 'content-length', 'transfer-encoding', 'connection']
    headers = [(name, value) for (name, value) in resp.raw.headers.items()
               if name.lower() not in excluded_headers]
    response = Response(resp.content, resp.status_code, headers)
    return response

@app.route("/<string:path>", methods=["GET", "POST"])
def proxy_documents(path):
    myurl=request.url.replace(request.host_url, 'https://api.natif.ai/')
    if request.method == 'GET':
        if '?' in myurl:
            pos=myurl.index('?')
            myurl = myurl[:pos] + "/" + myurl[pos:]
        else:
            myurl=myurl+'/'
    resp = requests.request(
        method=request.method,
        url=myurl,
        headers={key: value for (key, value) in request.headers if key != 'Host'},
        data=request.get_data(),
        cookies=request.cookies,
        allow_redirects=True)
    url=request.url.replace(request.host_url, 'https://api.natif.ai/')
    excluded_headers = ['content-encoding', 'content-length', 'transfer-encoding', 'connection']
    headers = [(name, value) for (name, value) in resp.raw.headers.items()
               if name.lower() not in excluded_headers]

    response = Response(resp.content, resp.status_code, headers)
    return response